"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KitchenSink = void 0;
var react_1 = __importDefault(require("react"));
var useForm_1 = require("../useForm");
var KitchenSink = function () {
    var _a = react_1.default.useState({ field: "" }), state = _a[0], setState = _a[1];
    var form = useForm_1.useForm({
        values: state,
        onChange: function (value) { return setState(__assign(__assign({}, state), value)); },
    });
    return (<div>
      {form.createFormItem("field", {
        adaptor: inputAdaptor,
        meta: { label: "Field" },
        required: true,
        validationMessages: {
            required: function (_a) {
                var label = _a.meta.label;
                return "Yo, " + label + " is required";
            },
        },
        custom: function (val) { return (val === "3" ? "3 is not allowed!" : ""); },
        customAsync: function (val) {
            return wait().then(function () { return (val === "4" ? "4 is not allow async!" : ""); });
        },
        validation: {
            type: "whitespace",
        },
    })(function (_a) {
        var label = _a.meta.label, errorText = _a.errorText, props = __rest(_a, ["meta", "errorText"]);
        return (<label>
          <span>{label}</span>
          <input {...props}/>
          <span>{errorText}</span>
        </label>);
    })}
    </div>);
};
exports.KitchenSink = KitchenSink;
var inputAdaptor = function (e) { return e.target.value; };
var wait = function () { return new Promise(function (y) { return setTimeout(y); }); };
//# sourceMappingURL=KitchenSink.jsx.map